//+------------------------------------------------------------------+
//|                                         FixEventsConnectorEA.mq5 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.1"
//#property strict
//#property show_inputs

#include "FixEventsConnectorEA.mqh"

#import "winmm.dll"
 int timeBeginPeriod(int uPeriod);
#import

#import "shlwapi.dll"
 bool PathFileExistsW(string path);
#import

input int port = 9002;
string server= "127.0.0.1";
int conn_socket;

#include "WinUser32.mqh"
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnInit()
{
   EventSetTimer(1);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+  
void OnTimer()
{
   Print("Init..");
   CleanAllGlobalVariables();
   
   ObjectCreate(0,script_name,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,script_name,OBJPROP_COLOR,clrWhiteSmoke);   
   ObjectSetInteger(0,script_name,OBJPROP_XDISTANCE,20);
   ObjectSetInteger(0,script_name,OBJPROP_YDISTANCE,30);
   ObjectSetString(0,script_name,OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,script_name,OBJPROP_FONTSIZE,12);
   ObjectSetString(0,script_name,OBJPROP_TEXT,"Script: FIX Events Connector");
   
   ObjectCreate(0,label_name,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,label_name,OBJPROP_COLOR,clrBlueViolet);   
   ObjectSetInteger(0,label_name,OBJPROP_XDISTANCE,20);
   ObjectSetInteger(0,label_name,OBJPROP_YDISTANCE,50);
   ObjectSetString(0,label_name,OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,label_name,OBJPROP_FONTSIZE,20);
   ObjectSetString(0,label_name,OBJPROP_TEXT,"Connecting to FIX Trader...");
   ChartRedraw();
   
   
   timeBeginPeriod(1);
    
   if (!ConnectToFixApp(conn_socket,server,port)) 
   {       
       Sleep(5000);
       return;
   }  
   //SendData("hello",conn_socket); 
      
   string status_str = "Connected";
   
   int max_time = 10;
   datetime send_time = TimeLocal(); 
           
           bool canceled=false;
           
           while (!canceled&&!IsStopped()&&(TimeLocal()-send_time)<max_time)
           {
              RecvData(conn_socket,server,port);
           
              for (int i=0;i<GlobalVariablesTotal();i++)
              {
                 string var_name = GlobalVariableName(i);
                 if (StringFind(var_name,"FIXBROKER_")!=-1)
                 {
                    status_str += " to "+StringSubstr(var_name,10);  
                    canceled = true;
                    break;
                 }
              }
               Sleep(10);
           }    

   
   ObjectSetInteger(0,label_name,OBJPROP_COLOR,clrBlueViolet);
   ObjectSetString(0,label_name,OBJPROP_TEXT,status_str);
   
   ChartRedraw();
   
   EventKillTimer();   
   while(!IsStopped())
    {
      RecvData(conn_socket,server,port);
      Sleep(2);
    }
    return;
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
 DisconnectFromFixApp(conn_socket_buy);
 CleanAllGlobalVariables();
 ObjectDelete(0,label_name);
 ObjectDelete(0,script_name);
 Print("Deinit");
}
//+------------------------------------------------------------------+

